const createBatch = namedActions => {
    const gateBatches = {};

    // sort actions per gate
    for(const name in namedActions) {
        const action = namedActions[name];
        gateBatches[action.gate] = {...gateBatches[action.gate], [name]:action}
    }

    // mark each gate set as a batch
    Object.keys(gateBatches).map(gate => {
        gateBatches[gate] = {
            __type: 'batch',
            actions: gateBatches[gate]
        }
    })

    // mark the entire object as a batch
    return {
        __type: 'batch',
        gateBatches
    };
}

export default createBatch;
